<!DOCTYPE html>
<html>

  <body>

	<?php
		$vcSequence="";
		$vcVotes=0;
	  $totalVotes=0;
		unset ($includedSequences);
		$includedSequencesIndex = -1;
		$randomIndex=0;	  
		$sequenceCount == 0;
		$line="";
		$lineLen=0;
		$arrayIndex=0;
		unset ($coolDownSequences);
		$sequence="";
		
  	/* Read sequences */
	  $seqFile = fopen("sequences.txt", "r") or die("Unable to open sequences.txt file!");

		/* Get total number of votes */
		$myfile = fopen("voteCount.txt", "r") or die("Unable to open voteCount.txt file!");

		while(! feof($myfile))
			{
			list($vcSequence,$vcVotes) = explode(',', fgets($myfile));

			if (strlen($vcSequence)>0)
				{
				$totalVotes=$totalVotes+$vcVotes;
				}
			}
	
		fclose($myfile);		

		
		//if there are no votes, then pick a random sequence to play (that is not in cooldown)

		if ($totalVotes==0)
			{
			while(! feof($seqFile))
				{
				$title="";
				$pic="";
				$sequence="";
				$media="";
				$length=0;
				$votes=0;

				$doNotIncludeSequence=0;
				$txt="";
				
				list($title,$pic,$sequence,$media,$length) = explode(',', fgets($seqFile));
	
				if (strlen($title)>0) 
					{ 
					/* If sequence is in CoolDown table, then don't add it to array */
					$myfile = fopen("coolDown.txt", "r") or die("Unable to open coolDown.txt file!");

					while(! feof($myfile))
						{
						$txt=trim(fgets($myfile));

						if (strlen($txt)>0)
							{

							if (strtolower($txt)==strtolower($sequence))
								{
								$doNotIncludeSequence=1;	
								}
							}
						}

					fclose($myfile);

					if ($doNotIncludeSequence<1)
						{
						//add sequence to array
						++$includedSequencesIndex;
						$includedSequences[$includedSequencesIndex]=$sequence;
						}
					}	  
				}

		  fclose($seqFile);
			
			
			//Randomly choose a sequence
			$randomIndex=rand(0,$includedSequencesIndex);
			
			$randomSequence=$includedSequences[$randomIndex];
			}

		//------------------------------------------------------------------------------------------------------------------------
		//Add to cool-down list, remove oldest entry from list
		
		//If voted sequence is playing next (not random), get sequence name
		if ($totalVotes>0)
			{
	
			if (file_exists('topsequence.txt'))
				{
				$myfile = fopen("topsequence.txt", "r");
				$sequence=fgets($myfile);
				fclose($myfile);
				
				//Add voted sequence to log
				//Append information to log file
				date_default_timezone_set("America/New_York");
				//'long' is for website, 'short' is for tune-to sign
				$loc = ip_info("Visitor", "long");
				$time = ltrim(date("n/j/Y",time())) . " at " . ltrim(date("g:ia",time())) . " EDT";
				$log = "\"" . $loc . "\", \"played sequence: " . substr($sequence,0,-5) . "\", \"" . $time . "\"";
				$myfile = fopen("log.txt", "a") or die("Unable to append log.txt file!");
				fwrite($myfile, "\n" . $log);
				fclose($myfile);
				
				// Refresh log frame
				$myFile = fopen('refreshLog.txt', 'w') or die("Unable to write refreshLog.txt file!");	
				$expireTime=time()+6;
				fwrite($myFile,$expireTime);
				fclose($myFile);
				}
			}
		
		else
			{
			$sequence=$randomSequence;
			}

		//Read list of existing cooldown sequences (if any)
		$myFile = fopen('coolDown.txt', 'r') or die("Unable to read coolDown.txt file!");
		
		while (!feof($myFile)) 
			{
			// Important!  Strip new line, carriage return, etc. from fgets
			$line = 	str_replace (array("\r\n", "\n", "\r"), '', fgets($myFile));
			// Determine if empty line was read
			$lineLen=strlen(trim($line));
					
			if ($lineLen > 0)
				{
				++$sequenceCount;
				$arrayIndex=$sequenceCount-1;
				$coolDownSequences[$arrayIndex]=$line;
				}
			}

		fclose($myFile);
				
		// Rewrite coolDown.txt, removing the oldest entry (if full) and adding chosen sequence
		$myFile = fopen('coolDown.txt', 'w') or die("Unable to write coolDown.txt file!");

		//no existing sequences in cooldown, so add chosen sequence
		if ($sequenceCount==0)
			{
			fwrite($myFile, $sequence);
			}
				
		//one existing sequence in cooldown, so add chosen sequence to existing one
		if ($sequenceCount==1)
			{
			fwrite($myFile, $coolDownSequences[0]."\n");
			fwrite($myFile, $sequence);
			}
				
		//two existing sequences in cooldown, so remove oldest sequence then add chosen sequence
		if ($sequenceCount==2)
			{
			fwrite($myFile, $coolDownSequences[1]."\n");
			fwrite($myFile, $sequence);
			}
		
		fclose($myFile);

		//------------------------------------------------------------------------------------------------------------------------
		//Create dynamic.json file
		$myfile = fopen("dynamic.json", "w") or die("Unable to write dynamic.json file!");

		fwrite($myfile, "{\n");
		fwrite($myfile, "\"playlistEntries\": [\n");
		fwrite($myfile, "{\n");
		
		//Read sequences.txt to retrieve media filename for sequence
		$seqFile = fopen("sequences.txt", "r") or die("Unable to open sequences.txt file!");

		while(! feof($seqFile))
			{
			$title="";
			$pic="";
			$seq="";
			$med="";
			$length=0;

			list($title,$pic,$seq,$med,$length) = explode(',', fgets($seqFile));

			if(strtolower($med)=="none")
			  {
				fwrite($myfile, "\"type\": \"sequence\",\n");
				
				$txt = "\"sequenceName\": \"".$sequence."\",\n";
				fwrite($myfile, $txt);
				break;
			  }
			
			elseif (strtolower($seq)==strtolower($sequence)) 
				{ 
				fwrite($myfile, "\"type\": \"both\",\n");
				
				$txt = "\"sequenceName\": \"".$sequence."\",\n";
				fwrite($myfile, $txt);

				$txt = "\"mediaName\": \"".$med."\"\n";
				fwrite($myfile, $txt);
				break;
				}
			}

		fclose($seqFile);
		
		fwrite($myfile, "}\n");
		fwrite($myfile, "]\n");
		fwrite($myfile, "}\n");

		fclose($myfile);		

		//------------------------------------------------------------------------------------------------------------------------
		//Reset voteCount.txt to zeros
		
		//Read sequences.txt and create temporary voteCount.tmp file
		$myFileTmp=fopen("voteCount.tmp","w") or die("Unable to write voteCount.tmp file!");
		$seqFile = fopen("sequences.txt", "r") or die("Unable to open sequences.txt file!");

		while(! feof($seqFile))
			{
			$title="";
			$pic="";
			$seq="";
			$med="";
			$length=0;

			list($title,$pic,$seq,$med,$length) = explode(',', fgets($seqFile));
	
			if (strlen($title)>0) 
				{ 
				++$sequenceCount;
				fputs($myFileTmp,$seq.",0\n");
				}
			}

		fclose($myFileTmp);
		fclose($seqFile);

		rename('voteCount.tmp', 'voteCount.txt');	

		//Set trigger to reset visitors' cookie to allow voting again.  Hidden.php will activate the trigger.
		$myFile = fopen('resetVoteCount.txt', 'w') or die("Unable to write resetVoteCount.txt file!");	
		$expireTime=time()+6;
		fwrite($myFile,$expireTime);
		fclose($myFile);

		//------------------------------------------------------------------------------------------------------------------------
		//Set sequence time countdown then display it
		
		//Get song length then start timer by placing trigger file for hidden frame to see/read
		$seqFile = fopen("sequences.txt", "r") or die("Unable to read sequences.txt file!");
		$timerFile = fopen("seqTime.txt", "w") or die("Unable to write seqTime.txt file!");
				
		while(! feof($seqFile))
			{
			list($title,$pic,$seq,$med,$length) = explode(',', fgets($seqFile));

			if (strlen($seq)>0)
				{

				if (trim($seq)==trim($sequence))
				  {
				  fwrite($timerFile, time()+$length);
				  }
				}	
			}

		fclose($seqFile);
		fclose($timerFile);

		//------------------------------------------------------------------------------------------------------------------------
		//Create message for status.txt
		$myfile = fopen("status.txt", "w") or die("Unable to write status.txt file!");
		fwrite($myfile, 'Now playing: '.substr($sequence,0,-5));
		fclose($myfile);
		
		$myFile = fopen('refreshStatus.txt', 'w') or die("Unable to write refreshStatus.txt file!");	
		$expireTime=time()+6;
		fwrite($myFile,$expireTime);
		fclose($myFile);

		//------------------------------------------------------------------------------------------------------------------------
		function ip_info($ip = NULL, $purpose = "location", $deep_detect = TRUE) 
			{
			$output = NULL;

			if (filter_var($ip, FILTER_VALIDATE_IP) === FALSE) 
				{
        $ip = $_SERVER["REMOTE_ADDR"];

        if ($deep_detect) 
					{
          
					if (filter_var(@$_SERVER['HTTP_X_FORWARDED_FOR'], FILTER_VALIDATE_IP))
                $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
          if (filter_var(@$_SERVER['HTTP_CLIENT_IP'], FILTER_VALIDATE_IP))
                $ip = $_SERVER['HTTP_CLIENT_IP'];
					}
				}

			$purpose    = str_replace(array("name", "\n", "\t", " ", "-", "_"), NULL, strtolower(trim($purpose)));
			//$support    = array("country", "countrycode", "state", "region", "city", "location", "address");
			$support    = array("long", "short");
			$continents = array(
        "AF" => "Africa",
        "AN" => "Antarctica",
        "AS" => "Asia",
        "EU" => "Europe",
        "OC" => "Australia (Oceania)",
        "NA" => "North America",
        "SA" => "South America"
				);

			if (filter_var($ip, FILTER_VALIDATE_IP) && in_array($purpose, $support)) 
				{
        $ipdat = @json_decode(file_get_contents("http://www.geoplugin.net/json.gp?ip=" . $ip));

        if (@strlen(trim($ipdat->geoplugin_countryCode)) == 2) 
					{
					$myCity=@$ipdat->geoplugin_city;
					$myRegion=@$ipdat->geoplugin_regionName;
					$myCountryName=@$ipdat->geoplugin_regionName;
					$myCountryCode=@$ipdat->geoplugin_countryCode;

					if ($purpose == "long")
						{

						//if city is not found, only list country and country code
						if(@strlen(trim($myCity)) == 0)
							{
							$output .= @$ipdat->geoplugin_countryName;
							$output .= ", ";
							$output .= @$ipdat->geoplugin_countryCode;				
							}

						else
							{
							$output .= @$ipdat->geoplugin_city;
							$output .= ", ";
							$output .= @$ipdat->geoplugin_regionName;
							$output .= ", ";
							$output .= @$ipdat->geoplugin_countryName;
							$output .= ", ";
							$output .= @$ipdat->geoplugin_countryCode;
							}
						}
		
					if ($purpose == "short")
						{
						//generate file header
						$output .= "<location>\n";
				
						//add random number_format
						$myRand= '';
						$a = mt_rand(1,32767);
						$output .= $a;
						$output .= "\n";
				
						//if city is not found, only list country
						if(@strlen(trim($myCity)) == 0)
							{
							$output .= @$ipdat->geoplugin_countryName;
							}

					else
						{
							
						//if United States, list city and state
						if ($myCountryCode=="US")
							{
							$output .= @$ipdat->geoplugin_city;
							$output .= ", ";
							$output .= @$ipdat->geoplugin_regionName;
							}
							
						//if outside US, list region and country
						else
							{
							$output .= @$ipdat->geoplugin_regionName;
							$output .= ", ";
							$output .= @$ipdat->geoplugin_countryName;
							}
						}
				
						//generate file footer
						$output .= "\n";
						$output .= "</location>";
						}
					}	
				}	
			
			return $output;
		}
	?>
  </body>
</html>
