<!DOCTYPE html>
<html>

  <head>
    <title>Vote frame</title>
		
		<link href="https://fonts.googleapis.com/css?family=Original+Surfer&display=swap" rel="stylesheet">

    <style>
      body {
        font-family: 'Original Surfer', cursive;
				text-shadow: 2px 2px 2px #000;
				font-size: 22px;
      }
    </style>
  </head>
	
  <body>
		<font color="white">

		<?php
			echo "<table>";
	  
			$totalVotes=0;
	  
			/* Read sequences */
			$seqFile = fopen("sequences.txt", "r") or die("Unable to open sequences.txt file!");

			/* Get total number of votes */
			$myfile = fopen("voteCount.txt", "r") or die("Unable to open voteCount.txt file!");

			while(! feof($myfile))
				{
				list($vcSequence,$vcVotes) = explode(',', fgets($myfile));

				if (strlen($vcSequence)>0)
					{
					$totalVotes=$totalVotes+$vcVotes;
					}
				}
	
			fclose($myfile);		
				
			$vcVotes=0;
			$vcSequence="";
		
			while(! feof($seqFile))
				{
				$title="";
				$pic="";
				$sequence="";
				$media="";
				$length=0;
				$votes=0;

				$vcSequence="";
				$vcVotes="";

				$doNotDisplaySequence=0;
				$txt="";
				$votedStatus="";
				$voteLink="";

				list($title,$pic,$sequence,$media,$length) = explode(',', fgets($seqFile));
	
				if (strlen($title)>0) 
					{ 
					/* If sequence is in CoolDown table, then don't display it */
					$myfile = fopen("coolDown.txt", "r") or die("Unable to open coolDown.txt file!");

					while(! feof($myfile))
						{
						$txt=trim(fgets($myfile));

						if (strlen($txt)>0)
							{

							if (strtolower($txt)==strtolower($sequence))
								{
								/*echo "Sequence will not be displayed (cooldown)";*/
								$doNotDisplaySequence=1;	
								}
							}
						}

					fclose($myfile);
				
					/* Get number of votes for this sequence (if any) */
					$myfile = fopen("voteCount.txt", "r") or die("Unable to open voteCount.txt file!");

					while(! feof($myfile))
						{
						list($vcSequence,$vcVotes) = explode(',', fgets($myfile));

						if (strlen($vcSequence)>0)
							{
		
							if (strtolower($vcSequence)==strtolower($sequence))
								{
								$votes=$vcVotes;
								/*echo "Votes found for ",$sequence,": ",$votes,"<br>";*/
								}
							}	
						}
	
					fclose($myfile);
		
					/* Set-up vote link */
		
					$votedSequence=$_COOKIE["votedSequence"];
					$votedStatus=$_COOKIE["votedStatus"];

					// If visitor voted, display "Voted" for chosen sequence instead of a link
					if ($sequence==$votedSequence and $votedStatus=="true")
						{
						$voteLink="Voted";	
						}

					// Allow visitor to add to votes
					else if ($votedStatus=="false")
						{
						$voteLink="<a href=\"voteAction.php?seq=" . $sequence . "\"><img src=\"pageGraphics/vote-button-green.png\" title=\"Click here to vote\" alt=\"Click here to vote\" width=\"90%\" height=\"40\"></a>";
						}
		  
					/* Display sequence */	
					if ($doNotDisplaySequence!==1)
						{
						echo '<tr>';
						echo "<td width=\"17%\">";
						echo "<img src=\"sequencePics/" ,$pic,"\""," alt=\"",$title,"\">";
						echo "</td>";
						echo "<td width=\"47%\">";
						echo $title;
						echo "</td>";
						echo "<td width=\"13%\" align=\"center\">";
						echo $votes;
						echo "</td>";
						echo "<td width=\"23%\" align=\"center\">";
						echo $voteLink;
						echo "</td>";
						}
			
					echo "</tr>";
					}	  
				}
			
			fclose($seqFile);
			echo "</table>";
		?>
  </body>
</html>
